Attribute VB_Name = "FileIO_Code"
Option Explicit

Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Type WIN32_FIND_DATA
            dwFileAttributes   As Long
            ftCreationTime   As FILETIME
            ftLastAccessTime   As FILETIME
            ftLastWriteTime   As FILETIME
            nFileSizeHigh   As Long
            nFileSizeLow   As Long
            dwReserved0   As Long
            dwReserved1   As Long
            cFileName   As String * 255
            cAlternate   As String * 14
End Type

Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Public Function GetFileInformations(theFile As String) As String
    '1/300000 der Originalfile
    Dim FileNum%
    Dim Temp As String
    Dim F As Integer
    FileNum% = FreeFile
    Open theFile For Binary Access Read As FileNum%
    Temp = Space$(Int(LOF(FileNum%) / 300000))
    If Not Temp = "" Then
        Get #FileNum%, Int(LOF(FileNum%) / 2), Temp
        F = InStr(Temp, "|")
        If F = 0 Then F = InStr(Temp, Chr$(13))
        If F = 0 Then F = InStr(Temp, Chr$(26))
        Do While Not F = 0
            Temp = Left$(Temp, F - 1) + Right$(Temp, Len(Temp) - F)
            F = InStr(Temp, "|")
            If F = 0 Then F = InStr(Temp, Chr$(13))
            If F = 0 Then F = InStr(Temp, Chr$(26))
        Loop
    End If
    Close FileNum%
    GetFileInformations = Temp
End Function

Public Function TestFile(theFile As String) As Boolean
    On Error GoTo ErrorTestFile
    Dim FileNum%
    FileNum% = FreeFile
    Open theFile For Binary As FileNum%
    Close FileNum%
    TestFile = True
    Exit Function
ErrorTestFile:
    TestFile = False
    Exit Function
End Function

Public Function DateiErweiterung(ByVal theFile As String, Optional MitPunkt As Boolean = False) As String
    theFile = Replace(theFile, "/", "\")
    Dim X As Long
    X = InStrRev(theFile, "\")
    If X <> 0 Then
        theFile = Right$(theFile, Len(theFile) - X)
    End If
    X = InStrRev(theFile, ".")
    If X <> 0 Then
        DateiErweiterung = IIf(MitPunkt, ".", "") + Right$(theFile, Len(theFile) - X)
    End If
End Function

Public Function DateiOhneErweiterung(ByVal theFile As String) As String
    theFile = Replace(theFile, "/", "\")
    Dim X As Long
    X = InStrRev(theFile, "\")
    If X <> 0 Then
        theFile = Right$(theFile, Len(theFile) - X)
    End If
    X = InStrRev(theFile, ".")
    If X <> 0 Then
        DateiOhneErweiterung = Left$(theFile, X - 1)
    Else
        DateiOhneErweiterung = theFile
    End If
End Function

Public Function GetFileName(ByVal theFile As String) As String
    Dim X As Integer
    theFile = Replace(theFile, "/", "\")
    Do While Left$(theFile, 1) = "\"
        theFile = Right$(theFile, Len(theFile) - 1)
    Loop
    Do While Right$(theFile, 1) = "\"
        theFile = Left$(theFile, Len(theFile) - 1)
    Loop
    X = InStrRev(theFile, "\")
    If X <> 0 Then
        GetFileName = Right$(theFile, Len(theFile) - X)
    Else
        GetFileName = theFile
    End If
End Function

Public Function GetFilePath(theFile As String) As String
    Dim X As Integer
    Dim Temp As String
    Dim AnzCutLeft As Integer
    AnzCutLeft = 0
    Temp = Replace(theFile, "/", "\")
    Do While Left$(Temp, 1) = "\"
        Temp = Right$(Temp, Len(Temp) - 1)
        AnzCutLeft = AnzCutLeft + 1
    Loop
    Do While Right$(Temp, 1) = "\"
        Temp = Left$(Temp, Len(Temp) - 1)
    Loop
    X = InStrRev(Temp, "\")
    If X <> 0 Then
        GetFilePath = Left$(theFile, X - 1 + AnzCutLeft)
    Else
        GetFilePath = ""
    End If
End Function

Public Sub SetOption(theFile As String, theValue As String)
    Dim FileNum%
    FileNum% = FreeFile
    Open theFile For Output As FileNum%
    Print #FileNum%, theValue
    Close FileNum%
End Sub

Public Function GetOption(theFile As String, Optional StandardValue As String) As String
    If Dir$(theFile) = "" Then SetOption theFile, StandardValue
    Dim FileNum%
    Dim Temp As String
    FileNum% = FreeFile
    Open theFile For Input As FileNum%
    If Not EOF(FileNum%) Then Line Input #FileNum%, Temp
    Close FileNum%
    GetOption = Temp
End Function

Public Sub CreateFile(FileName As String)
    Dim FileNum%
    FileNum% = FreeFile
    Open FileName For Output As FileNum%
    Close FileNum%
End Sub

Public Sub IfNotExistThenCreate(FileName As String)
    If Dir$(FileName, 7) = "" Then CreateFile FileName
End Sub

Public Sub IfExistThenDelete(FileName As String)
    If Dir$(FileName) <> "" Then Kill FileName
End Sub

Public Sub WriteFile(theFile As String, TheContent As String)
    IfExistThenDelete theFile
    Dim FileNum%
    FileNum% = FreeFile
    Open theFile For Binary Access Write As FileNum%
    Put #FileNum%, 1, TheContent
    Close FileNum%
End Sub

Public Function ReadFile(theFile As String) As String
    Dim FileNum%
    FileNum% = FreeFile
    Open theFile For Binary Access Read As FileNum%
    ReadFile = Space$(LOF(FileNum%))
    Get #FileNum%, 1, ReadFile
    Close FileNum%
End Function
